;*********************************************************
;	 16F628a      smb380 
;********************************************************* 

 ; __CONFIG _CP_OFF & _WDT_OFF & _BODEN_OFF & _PWRTE_OFF & _XT_OSC & _MCLRE_OFF & _LVP_OFF
 ;  (3f18h)    

       LIST p=16F628a
#include <p16f628A.inc> 
 errorlevel -302

        CBLOCK   20h 	
        
        _N              ;    
        TEMP		;
	TEMP2 		;
	TEMP3 		;
	TEMP4
	temp4
	DISPDATA	;    
	LCDTIME		;   
      
	dgx		;      X
	egx		;      X
	ddgx		;       X
	
	dgy		;      y
	egy		;      y
	ddgy		;       y
	
	dgz		;      z
	egz		;      z
	ddgz		;       z
	
	dgt		;      t
	egt		;      t
	ddgt		;       t

	taimer1  
	taimer2 
	LOOP1
	RT1
	DIP
	MDP
	KN1		; 1
	znakx		;  "X"
	znaky		;  "Y"
	znakz		;  "Z"
	znakt		;  "t"
	z_zero
	memory_x
	memory_y
	memory_z
	memory_znx
	memory_zny
	memory_znz
	znt
	znx_n
	zny_n
	znz_n
	rprf1
	rprf2
	rprf3
	rprf4
	rpinv
	ee_w
	timeotkl
	rezultat
	rezultat_2
	rezultat_3
	usilenie
	diapazon
	smeshenie
	spiTempOut	
	spiTempIn
	spiCounter
	
	ENDC

#define	mmcCS	PORTB,3	;  
#define	mmcSDI	PORTB,5	;  
#define	mmcSCK	PORTB,1	; 
#define	mmcSDO	PORTB,2	;  
   
;******************************************************
;       \.
;******************************************************

        ORG  0000H
        goto MAIN
        org     4
        goto    int

MAIN	clrf	PORTA		;   
	clrf	PORTB		;   
	MOVLW 0X07		; 
	MOVWF CMCON

	bsf	STATUS,RP0	;  1 
	movlw	b'00000000'
     	movwf   TRISA   	;       
	movlw	b'11110001'	;     
	movwf	TRISB
	bcf	PCON,3		;f=32 
	bcf	STATUS,RP0	;    0 

	bsf	mmcSDI	;
	bsf	mmcSCK	;
	bsf	mmcSDO	;
	bsf	mmcCS	;

	movlw	2bh
	movwf	znakx		;  "+"
	movwf	znaky
	movwf	znakz
	movwf	znakt

	call	clrxyz
	CALL 	INITLCD
	goto	MAIN_1
	
;*************************************************           
;	  
; 	
;*************************************************		
;*************************************************
;    -30__+97
; SMB_380
;*************************************************		
		
t_table:
	addwf	PCL,F
  dt	1e, 1d, 1c, 1b, 1a, 19, 18, 17, 16, 15, 14, 13  
  dt	12, 11, 10, 0f, 0e, 0d, 0c, 0b, 0a,  9,  8,  7 
  dt	 6,  5,  4,  3,  2,  1,  0,  1,  2,  3,  4,  5
  dt     6,  7,  8,  9, 0a, 0b, 0c, 0d, 0e, 0f, 10, 11
  dt	12, 13, 14, 15, 16, 17, 18, 19, 1a, 1b, 1c, 1d
  dt	1e, 1f, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29
  dt    2a, 2b, 2c, 2d, 2e, 2f, 30, 31, 32, 33, 34, 35
  dt    36, 37, 38, 39, 3a, 3b, 3c, 3d, 3e, 3f, 40, 41
  dt	42, 43, 44, 45, 46, 47, 48, 49, 4a, 4b, 4c, 4d
  dt	4e, 4f, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59
  dt	5a, 5b, 5c, 5d, 5e, 5f, 60, 61, 62, 63, 64, 65
  
;******************************************************
;******************************************************
;******************************************************
MAIN_1	nop
	call	time1
	call	dnp2		; "<X> <Y> <Z>"
	call	DISPLAY2	; "XX,X YY,Y ZZ,Z"
	
;***************************************************
	
	call	range_2		;  
	
fe	bsf	mmcCS		;
	movlw	b'10000010'	; 02h
	movwf	spiTempOut	;  acc_x
	bcf	mmcCS	
	call	SPI
			
	movlw	b'11111111'
	movwf	spiTempOut	;
	call	SPI
	movf	spiTempIn,0	;
	movwf	rezultat_2	;  .
			
	movlw	b'11111111'
	movwf	spiTempOut	;
	call	SPI
	movf	spiTempIn,0	;
	movwf	rezultat	;  . 
	movwf	memory_znx
	bsf	mmcCS		;

	call	schetx		; 
		
;**************************************************

	bsf	mmcCS		;
	movlw	b'10000100'	; 04h
	movwf	spiTempOut	;  acc_y
	bcf	mmcCS	
	call	SPI
		
	movlw	b'11111111'
	movwf	spiTempOut	;
	call	SPI
	movf	spiTempIn,0	;
	movwf	rezultat_2	; y . 
		
	movlw	b'11111111'
	movwf	spiTempOut	;
	call	SPI
	movf	spiTempIn,0	;
	movwf	rezultat	; y . 
	movwf	memory_zny
	bsf	mmcCS	

	call	schety		; 
		
;************************************************

	bsf	mmcCS		;
	movlw	b'10000110'	; 06h
	movwf	spiTempOut	;  acc_z
	bcf	mmcCS	
	call	SPI
		
	movlw	b'11111111'
	movwf	spiTempOut	;
	call	SPI
	movf	spiTempIn,0	;
	movwf	rezultat_2	; z . 
	
	movlw	b'11111111'
	movwf	spiTempOut	;
	call	SPI
	movf	spiTempIn,0	;
	movwf	rezultat	; z . 
	movwf	memory_znz
	bsf	mmcCS	

	call	schetz		; 
		
;************************************************

	bsf	mmcCS		;
	movlw	b'10001000'	; 08h
	movwf	spiTempOut	;  temp
	bcf	mmcCS	
	call	SPI
			
	movlw	b'11111111'
	movwf	spiTempOut	;
	call	SPI
	movf	spiTempIn,0	;
	movwf	rezultat	; t
	bsf	mmcCS	

	call	schett		; 
	
;**********************************************************
;  X  Y    
;**********************************************************

	movlw	0eeh
	movwf	z_zero
	movlw	0h
	xorwf	egx,0
	btfss	STATUS,Z
	goto	zero	
	movlw	0h
	xorwf	egy,0
	btfss	STATUS,Z
	goto	zero
	movlw	0h
	xorwf	ddgx,0
	btfss	STATUS,Z
	goto	zero	
	movlw	0h
	xorwf	ddgy,0
	btfss	STATUS,Z
	goto	zero	
	
	movlw	2ah
	movwf	z_zero
zero	nop
;**********************************************************

	call	dnp2		; "<X> <Y> <Z>"
	call	DISPLAY2	; "XX,X YY,Y ZZ,Z"
	call	clrxyz		; 

	btfss	PORTB,4
	goto	kn0	
	call	pause_01sek
	goto	fe

kn0	movlw	57h
	movwf	z_zero
	call	dnp2		; "<X> <Y> <Z>"
	call	DISPLAY2	; "XX,X YY,Y ZZ,Z"
kn1	btfss PORTB,4
	goto	kn1
	goto	reg2

;*******;   *******
;********************************************

;********************************************
;   "W"
;********************************************
reg2	call	pause_01sek
	
	bsf	mmcCS		;
	movlw	b'10000010'	; 02h
	movwf	spiTempOut	;  acc_x
	bcf	mmcCS	
	call	SPI
			
	movlw	b'11111111'
	movwf	spiTempOut	;
	call	SPI
	movf	spiTempIn,0	;
	movwf	rezultat_2	;  .
			
	movlw	b'11111111'
	movwf	spiTempOut	;
	call	SPI
	movf	spiTempIn,0	;
	movwf	rezultat	;  . 
	bsf	mmcCS		;

	call	schetxw		; 
		
;**************************************************

	bsf	mmcCS		;
	movlw	b'10000100'	; 04h
	movwf	spiTempOut	;  acc_y
	bcf	mmcCS	
	call	SPI
		
	movlw	b'11111111'
	movwf	spiTempOut	;
	call	SPI
	movf	spiTempIn,0	;
	movwf	rezultat_2	; y . 
		
	movlw	b'11111111'
	movwf	spiTempOut	;
	call	SPI
	movf	spiTempIn,0	;
	movwf	rezultat	; y . 
	bsf	mmcCS	

	call	schetyw		; 
		
;************************************************

	bsf	mmcCS		;
	movlw	b'10000110'	; 06h
	movwf	spiTempOut	;  acc_z
	bcf	mmcCS	
	call	SPI
		
	movlw	b'11111111'
	movwf	spiTempOut	;
	call	SPI
	movf	spiTempIn,0	;
	movwf	rezultat_2	; z . 
	
	movlw	b'11111111'
	movwf	spiTempOut	;
	call	SPI
	movf	spiTempIn,0	;
	movwf	rezultat	; z . 
	bsf	mmcCS	

	call	schetzw		; 
		
;************************************************

	bsf	mmcCS		;
	movlw	b'10001000'	; 08h
	movwf	spiTempOut	;  temp
	bcf	mmcCS	
	call	SPI
			
	movlw	b'11111111'
	movwf	spiTempOut	;
	call	SPI
	movf	spiTempIn,0	;
	movwf	rezultat	; t
	bsf	mmcCS	

	call	schett		; 

	call	dnp2		; "<X> <Y> <Z>"
	call	DISPLAY2	; "XX,X YY,Y ZZ,Z"
	call	clrxyz		; 

	btfss	PORTB,4		;  ""
	goto	kn2		;  
	goto	reg2

kn2	movlw	0eeh
	movwf	z_zero
	call	dnp2		; "<X> <Y> <Z>"
	call	DISPLAY2	; "XX,X YY,Y ZZ,Z"
kn3	btfss PORTB,4		;  ""
	goto	kn3		
	goto	fe		;  

;********************************************

schetxw		clrf	znx_n
		movlw	2bh		; X "+"
		movwf	znakx
		btfss	rezultat,7
		goto	schetxw_2
		bsf	znx_n,0
		movlw	2dh		; X "-"
		movwf	znakx		
		comf	rezultat,1	;  =1   
		
schetxw_2	rlf	rezultat,1
		rlf	rezultat,1
		bcf	rezultat,0
		bcf	rezultat,1
		call	schmb

		movf	rezultat,0	;
 
	;************  *****************
		btfss	memory_znx,7
		bsf	znx_n,1

proban		movlw	0h
		xorwf	znx_n,0
		btfsc	STATUS,Z
		goto	raschet_1
		
		movlw	1h
		xorwf	znx_n,0
		btfsc	STATUS,Z
		goto	raschet_2
		
		movlw	2h
		xorwf	znx_n,0
		btfsc	STATUS,Z
		goto	raschet_3
		
		movlw	3h
		xorwf	znx_n,0
		btfsc	STATUS,Z
		goto	raschet_4

raschet_1	movlw	2bh		; "+"
		movwf	znakx
		nop			;  +
		movf	memory_x,0	;
		addwf	rezultat,w	;= w - memory_x
		btfsc	STATUS,C
		goto	psfe
		movlw	2dh		; "-"
		movwf	znakx
		movf	rezultat,0	;
		addwf	memory_x,w	;= w - rezultat
		goto	psfe
		
raschet_2	movlw	2bh		; "+"
		movwf	znakx
		nop			;  +
		movf	memory_x,0	;
		subwf	rezultat,w	;= w - memory_x
		btfsc	STATUS,C
		goto	psfe
		movlw	2dh		; "-"
		movwf	znakx
		movf	rezultat,0	;
		subwf	memory_x,w	;= w - rezultat		
		goto	psfe

raschet_3	movlw	2bh		; "+"
		movwf	znakx
		nop			;  +
		movf	memory_x,0	;
		subwf	rezultat,w	;= w - memory_x
		btfsc	STATUS,C
		goto	psfe
		movlw	2dh		; "-"
		movwf	znakx
		movf	rezultat,0	;
		subwf	memory_x,w	;= w - rezultat
		goto	psfe
	
raschet_4	movlw	2bh		; "+"
		movwf	znakx
		nop			;  +
		movf	memory_x,0	;
		addwf	rezultat,w	;= w - memory_x
		btfsc	STATUS,C
		goto	psfe
		movlw	2dh		; "-"
		movwf	znakx
		movf	rezultat,0	;
		addwf	memory_x,w	;= w - rezultat

;*************************************************
	
psfe		movwf	temp4		;   
		addlw	0a7h		;7fh
		btfss	STATUS,C
		goto	trb1
	
		movlw	45h		; 
		movwf	znakx
		movlw	42h
		movwf	egx
		movwf	ddgx
		clrf	temp4	
		return		;  

trb1		movf	temp4,0
		call	g_table		;   
		bcf	PCLATH,1
		bcf	PCLATH,2
		movwf	RT1
	
schet_1w	movlw	.0
		xorwf	RT1,0
		btfsc	STATUS,Z
		return
		decf	RT1,1		
		call	stxw
		goto	schet_1w

;********************************************
; ..   
;********************************************

stxw	incf	ddgx,1		;  
	movlw	.10
	xorwf	ddgx,0
	btfss	STATUS,Z
	return

	clrf	ddgx
	incf	egx,1		; 
	movlw	.10
	xorwf	egx,0
	btfss	STATUS,Z
	return	

	clrf	ddgx
	clrf	egx
	incf	dgx,1		; 
	movlw	.10
	xorwf	dgx,0
	btfss	STATUS,Z
	return

;*************************************************

schetyw		movlw	2bh		; y "+"
		movwf	znaky		
		btfss	rezultat,7
		goto	schetyw_2
		movlw	2dh
		movwf	znaky		; X "-"
		comf	rezultat,1	;  =1   			;  "+"

schetyw_2	rlf	rezultat,1
		rlf	rezultat,1
		bcf	rezultat,0
		bcf	rezultat,1
		call	schmb

		movf	rezultat,0	; 

	;************  *****************
	
		btfss	memory_zny,7
		bsf	zny_n,1

		movlw	0h
		xorwf	zny_n,0
		btfsc	STATUS,Z
		goto	raschety_1
		
		movlw	1h
		xorwf	zny_n,0
		btfsc	STATUS,Z
		goto	raschety_2
		
		movlw	2h
		xorwf	zny_n,0
		btfsc	STATUS,Z
		goto	raschety_3
		
		movlw	3h
		xorwf	zny_n,0
		btfsc	STATUS,Z
		goto	raschety_4


raschety_1	movlw	2bh		; "+"
		movwf	znaky
		nop			;  +
		movf	memory_y,0	;
		subwf	rezultat,w	;= w - memory_x
		btfsc	STATUS,C
		goto	psfey
		movlw	2dh		; "-"
		movwf	znaky
		movf	rezultat,0	;
		subwf	memory_y,w	;= w - rezultat
		goto	psfey
		
raschety_2	movlw	2bh		; "+"
		movwf	znaky
		nop			;  +
		movf	memory_y,0	;
		addwf	rezultat,w	;= w - memory_x
		btfsc	STATUS,C
		goto	psfey
		movlw	2dh		; "-"
		movwf	znaky
		movf	rezultat,0	;
		addwf	memory_y,w	;= w - rezultat		
		goto	psfey

raschety_3	movlw	2bh		; "+"
		movwf	znaky
		nop			;  +
		movf	memory_y,0	;
		addwf	rezultat,w	;= w - memory_x
		btfsc	STATUS,C
		goto	psfey
		movlw	2dh		; "-"
		movwf	znaky
		movf	rezultat,0	;
		addwf	memory_y,w	;= w - rezultat
		goto	psfey
	
raschety_4	movlw	2bh		; "+"
		movwf	znaky
		nop			;  +
		movf	memory_y,0	;
		subwf	rezultat,w	;= w - memory_x
		btfsc	STATUS,C
		goto	psfey
		movlw	2dh		; "-"
		movwf	znaky
		movf	rezultat,0	;
		subwf	memory_y,w	;= w - rezultat

;***********************************************************
	
psfey		movwf	temp4	;   
		addlw	0a7h	;7fh
		btfss	STATUS,C
		goto	trby1
	
		movlw	45h		; 
		movwf	znaky
		movlw	42h
		movwf	egy
		movwf	ddgy
		clrf	temp4	
		return			;  

trby1		movf	temp4,0
		call	g_table		;   
		bcf	PCLATH,1
		bcf	PCLATH,2
		movwf	RT1
			
schet_2w	movlw	.0
		xorwf	RT1,0
		btfsc	STATUS,Z
		return
		decf	RT1,1
		call	styw
		goto	schet_2w

;********************************************
; ..   y 
;********************************************

styw	incf	ddgy,1		;  
	movlw	.10
	xorwf	ddgy,0
	btfss	STATUS,Z
	return

	clrf	ddgy
	incf	egy,1		; 
	movlw	.10
	xorwf	egy,0
	btfss	STATUS,Z
	return	

	clrf	ddgy
	clrf	egy
	incf	dgy,1		; 
	movlw	.10
	xorwf	dgy,0
	btfss	STATUS,Z
	return

;************************************************

schetzw		movlw	2bh		; z "+"
		movwf	znakz		
		btfss	rezultat,7
		goto	schetzw_2
		movlw	2dh
		movwf	znakz		; X "-"
		comf	rezultat,1	;  =1   			;  "+"

schetzw_2	rlf	rezultat,1
		rlf	rezultat,1
		bcf	rezultat,0
		bcf	rezultat,1
		call	schmb

		movf	rezultat,0	; 
	;************  *****************
		btfss	memory_znz,7
		bsf	znz_n,1

		movlw	0h
		xorwf	znz_n,0
		btfsc	STATUS,Z
		goto	raschetz_1
		
		movlw	1h
		xorwf	znz_n,0
		btfsc	STATUS,Z
		goto	raschetz_2
		
		movlw	2h
		xorwf	znz_n,0
		btfsc	STATUS,Z
		goto	raschetz_3
		
		movlw	3h
		xorwf	znz_n,0
		btfsc	STATUS,Z
		goto	raschetz_4


raschetz_1	movlw	2bh		; "+"
		movwf	znakz
		nop			;  +
		movf	memory_z,0	;
		subwf	rezultat,w	;= w - memory_x
		btfsc	STATUS,C
		goto	psfez
		movlw	2dh		; "-"
		movwf	znakz
		movf	rezultat,0	;
		subwf	memory_z,w	;= w - rezultat
		goto	psfez
		
raschetz_2	movlw	2bh		; "+"
		movwf	znakz
		nop			;  +
		movf	memory_z,0	;
		addwf	rezultat,w	;= w - memory_x
		btfsc	STATUS,C
		goto	psfez
		movlw	2dh		; "-"
		movwf	znakz
		movf	rezultat,0	;
		addwf	memory_z,w	;= w - rezultat		
		goto	psfez

raschetz_3	movlw	2bh		; "+"
		movwf	znakz
		nop			;  +
		movf	memory_z,0	;
		addwf	rezultat,w	;= w - memory_x
		btfsc	STATUS,C
		goto	psfez
		movlw	2dh		; "-"
		movwf	znakz
		movf	rezultat,0	;
		addwf	memory_z,w	;= w - rezultat
		goto	psfez
	
raschetz_4	movlw	2bh		; "+"
		movwf	znakz
		nop			;  +
		movf	memory_z,0	;
		subwf	rezultat,w	;= w - memory_x
		btfsc	STATUS,C
		goto	psfez
		movlw	2dh		; "-"
		movwf	znakz
		movf	rezultat,0	;
		subwf	memory_z,w	;= w - rezultat

;***********************************************************
	
psfez		movwf	temp4		;   
		addlw	0a7h		;7fh
		btfss	STATUS,C
		goto	trbz1
	
		movlw	45h		; 
		movwf	znakz
		movlw	42h
		movwf	egz
		movwf	ddgz
		clrf	temp4	
		return			;  

trbz1		movf	temp4,0
		call	g_table		;   
		
		bcf	PCLATH,1
		bcf	PCLATH,2
		movwf	RT1
			
schet_3w	movlw	.0
		xorwf	RT1,0
		btfsc	STATUS,Z
		return
		decf	RT1,1		
		call	stz
		goto	schet_3w

;********************************************
; ..   
;********************************************

stzw	incf	ddgz,1		;  
	movlw	.10
	xorwf	ddgz,0
	btfss	STATUS,Z
	return

	clrf	ddgz
	incf	egz,1		; 
	movlw	.10
	xorwf	egz,0
	btfss	STATUS,Z
	return	

	clrf	ddgz
	clrf	egz
	incf	dgz,1		; 
	movlw	.10
	xorwf	dgz,0
	btfss	STATUS,Z
	return

;********************************************

;***************   **********
;**********************************************
;**********************************************

;**********************************************
;..     2 g
;**********************************************
range_2	
	bsf	mmcCS		;
	movlw	b'10010100'	; 14h
	movwf	spiTempOut	;  
	bcf	mmcCS	
	call	SPI
		
	movlw	b'11111111'
	movwf	spiTempOut	;
	call	SPI
	movf	spiTempIn,0	;
	movwf	diapazon	; 
	bsf	mmcCS

	bsf	diapazon,3	; range=
	bcf	diapazon,4	;
	
	bcf	diapazon,2	; bandwidth
	bcf	diapazon,1	;25 
	bcf	diapazon,0	;

	bsf	mmcCS
	movlw	b'00010100'	; 14h
	movwf	spiTempOut	;  
	bcf	mmcCS	
	call	SPI
	movf	diapazon,0
	movwf	spiTempOut
	call	SPI		; 
	bsf	mmcCS
	return

;********************************************

schetx		movlw	2bh		; X "+"
		movwf	znakx		
		btfss	rezultat,7
		goto	schetx_2
		movlw	2dh		; X "-"
		movwf	znakx		
		comf	rezultat,1	;  =1   
		
schetx_2	rlf	rezultat,1
		rlf	rezultat,1
		bcf	rezultat,0
		bcf	rezultat,1
		call	schmb

		movf	rezultat,0	; 
		movwf	memory_x
		call	g_table		;   
		
		bcf	PCLATH,1
		bcf	PCLATH,2
		movwf	RT1
	
schet_1		movlw	.0
		xorwf	RT1,0
		btfsc	STATUS,Z
		return
		decf	RT1,1		
		call	stx
			
		goto	schet_1

;********************************************
; ..    
;********************************************	
		
schmb		bcf	rezultat_2,0	; 6  
		bcf	rezultat_2,1	;
		bcf	rezultat_2,2	;
		bcf	rezultat_2,3	;
		bcf	rezultat_2,4	;
		bcf	rezultat_2,5	;

		movlw	40h
		xorwf	rezultat_2,0
		btfsc	STATUS,Z
		goto	smd1		;  0,  
		movlw	80h
		xorwf	rezultat_2,0
		btfsc	STATUS,Z
		goto	smd2		;  0,  
		movlw	0c0h
		xorwf	rezultat_2,0
		btfsc	STATUS,Z
		goto	smd3		;  0,  
		return 			; 1,   
		
smd3		incf	rezultat,1	
smd2		incf	rezultat,1	
smd1		incf	rezultat,1	
	
		return

;********************************************
; ..   
;********************************************

stx	incf	ddgx,1		;  
	movlw	.10
	xorwf	ddgx,0
	btfss	STATUS,Z
	return

	clrf	ddgx
	incf	egx,1		; 
	movlw	.10
	xorwf	egx,0
	btfss	STATUS,Z
	return	

	clrf	ddgx
	clrf	egx
	incf	dgx,1		; 
	movlw	.10
	xorwf	dgx,0
	btfss	STATUS,Z
	return

;*************************************************

schety		movlw	2bh		; y "+"
		movwf	znaky		
		btfss	rezultat,7
		goto	schety_2
		movlw	2dh
		movwf	znaky		; X "-"
		comf	rezultat,1	;  =1   			;  "+"

schety_2	rlf	rezultat,1
		rlf	rezultat,1
		bcf	rezultat,0
		bcf	rezultat,1
		call	schmb

		movf	rezultat,0	; 
		movwf	memory_y
		call	g_table		;   
		
		bcf	PCLATH,1
		bcf	PCLATH,2
		movwf	RT1
			
schet_2		movlw	.0
		xorwf	RT1,0
		btfsc	STATUS,Z
		return
		decf	RT1,1
		
		call	sty
			
		goto	schet_2

;********************************************
; ..   y 
;********************************************

sty	incf	ddgy,1		;  
	movlw	.10
	xorwf	ddgy,0
	btfss	STATUS,Z
	return

	clrf	ddgy
	incf	egy,1		; 
	movlw	.10
	xorwf	egy,0
	btfss	STATUS,Z
	return	

	clrf	ddgy
	clrf	egy
	incf	dgy,1		; 
	movlw	.10
	xorwf	dgy,0
	btfss	STATUS,Z
	return

;************************************************

schetz		movlw	2bh		; z "+"
		movwf	znakz		
		btfss	rezultat,7
		goto	schetz_2
		movlw	2dh
		movwf	znakz		; X "-"
		comf	rezultat,1	;  =1   			;  "+"

schetz_2	rlf	rezultat,1
		rlf	rezultat,1
		bcf	rezultat,0
		bcf	rezultat,1
		call	schmb

		movf	rezultat,0	; 
		movwf	memory_z
		call	g_table		;   
		
		bcf	PCLATH,1
		bcf	PCLATH,2
		movwf	RT1
			
schet_3		movlw	.0
		xorwf	RT1,0
		btfsc	STATUS,Z
		return
		decf	RT1,1		
		call	stz
		goto	schet_3

;********************************************
; ..   
;********************************************

stz	incf	ddgz,1		;  
	movlw	.10
	xorwf	ddgz,0
	btfss	STATUS,Z
	return

	clrf	ddgz
	incf	egz,1		; 
	movlw	.10
	xorwf	egz,0
	btfss	STATUS,Z
	return	

	clrf	ddgz
	clrf	egz
	incf	dgz,1		; 
	movlw	.10
	xorwf	dgz,0
	btfss	STATUS,Z
	return
;********************************************

schett		movlw	2bh
		movwf	znakt		; X "+"
		movf	rezultat,0	; 
		sublw	1eh
		btfss	STATUS,C
		goto	schett_3
		movlw	2dh
		movwf	znakt		; X "-"
					;  "+"
schett_3	movf	rezultat,0	; 
		movwf	RT1
		rrf	RT1,1	
         	bcf	RT1,7
		movf	RT1,0
		call	t_table	
		movwf	RT1
		
schett_1	movlw	.0
		xorwf	RT1,0
		btfsc	STATUS,Z
		return
		decf	RT1,1		
		call	stt
		goto	schett_1

;********************************************
; ..   
;********************************************

stt	incf	ddgt,1		;  
	movlw	.10
	xorwf	ddgt,0
	btfss	STATUS,Z
	return

	clrf	ddgt
	incf	egt,1		; 
	movlw	.10
	xorwf	egt,0
	btfss	STATUS,Z
	return	

	clrf	ddgt
	clrf	egt
	incf	dgt,1		; 
	movlw	.10
	xorwf	dgt,0
	btfss	STATUS,Z
	return

;*************************************************
;..    
;*************************************************
clrxyz	
	clrf	ddgx
	clrf	egx
	clrf	dgx
	
	clrf	dgy	;
	clrf	egy	;
	clrf	ddgy	;
	
	clrf	dgz	;
	clrf	egz	;
	clrf	ddgz	;

	clrf	dgt	;
	clrf	egt	;
	clrf	ddgt	;
	
	clrf	RT1
	clrf	TEMP
       	return

;****************p.p. *****************************

LCDWAIT: 
	clrf	LCDTIME		; Clear time downcounter
LCDWAITLOOP:
	nop			; Extend timerloop to 256
	decfsz	LCDTIME,F	; Decrement timer
 	goto	LCDWAITLOOP	; and loop if not down to zero again
	movwf	LCDTIME		; W contains outer loop value
	decfsz	LCDTIME,W	; Decrement
	goto	LCDWAIT
	return

;************..  ****************

time1	movlw	8h		
	movwf	taimer1 
ti1	decfsz	taimer1,F 
	goto 	ti1
	return

;************ .. _2 ************
pause_1sek
	movlw	0fh		
	movwf	taimer2
ti25	movlw	0FFh	
	movwf	taimer1 
ti35	nop
	nop
	nop
	nop
	nop
	decfsz	taimer1,F 
	goto 	ti35
	decfsz	taimer2,F
	goto	ti25
	return

;********************************************************
pause_01sek
	movlw	5h		
	movwf	taimer2
ti65	movlw	0Fh	
	movwf	taimer1 
ti75	nop
	nop		
	nop
	decfsz	taimer1,F 
	goto 	ti75
	decfsz	taimer2,F
	goto	ti65
	return

;********************************************************
;                
;********************************************************
INITLCD:
	movlw   0x5             ;  15  
	call    LCDWAIT		;   
 	movlw   b'00000011'     ;  30H  
	call	WRCOM_GKI	;    
	movlw   d'2'            ;  5 
	call    LCDWAIT		;
	movlw   b'00000011'     ;  30H  
	call	WRCOM_GKI	;    
	movlw   d'4'            ;  240 
	call    LCDWAIT		; 
	movlw   b'00000011'     ;  30H  
	call	WRCOM_GKI	;    
	movlw   b'00000010'     ;   4-  
	call	WRCOM_GKI	;    
	movlw   b'00000010'     ; 20H
	call	WRCOM_GKI	;    
	movlw   b'00001000'     ;  
	call	WRCOM_GKI	;               ; 

	movlw   b'00000000'     ;  
	call	WRCOM_GKI	;      
 	movlw   b'00001000'     ;  
	call	WRCOM_GKI	;      
	movlw   b'00000000'     ;  
	call	WRCOM_GKI	;      
 	movlw   b'00001100'     ;  
	call	WRCOM_GKI	;      
	call	DISPCLR		;  
	return

;*****************************************************
;     (     W)
;*****************************************************

WRCOM_GKI   	movwf   PORTA           ;   PORTA
		BCF	PORTA,7		;RS=0
		nop
		nop	
		BSF	PORTA,6		;E =1
		nop
		nop	
		BCF	PORTA,6		;E =0
		return

;*****************************************************
;     (    W)
;*****************************************************

WRD_GKI   	movwf   PORTA           ;  PORT A
		BSF	PORTA,7		;RS=1
		nop
		nop	
		BSF	PORTA,6		;E =1
		nop
		nop	
		BCF	PORTA,6		;E =0
		return

;**********************************************************
;	..      
;**********************************************************

SENDI	        movwf	DISPDATA	;    TEMP#
		swapf	DISPDATA,F	;    
		movf	DISPDATA,0	;   W
		call	WRCOM_GKI	;   
		swapf	DISPDATA,F	;   
		movf	DISPDATA,0	;   W
		call	WRCOM_GKI	;   
		return

;**********************************************************
;	..      
;**********************************************************
	
SENDD	        movwf	DISPDATA	;    TEMP#
		swapf	DISPDATA,F	;    
		movf	DISPDATA,0	;   W
		call	WRD_GKI		;   
		swapf	DISPDATA,F	;   
		movf	DISPDATA,0	;   W
		call	WRD_GKI		;   
		return

;****************************************************
;	..  
;****************************************************
DISPCLR	movlw   b'00000001'     ;  
	call	SENDI		;      
  	return

;*****************************************************
;	   1- 
;*****************************************************
LINE1	movlw	80h		;    1- 
	call	SENDI		; 1- 
	return			; 

;*****************************************************
;	   1-  2- 
;*****************************************************
LINE2	movlw	0c0h		;    1- 
	call	SENDI		; 2-  (   9 
	return			;  )

;******************************************************
;	 "<X> <Y> <Z>"
;******************************************************

dnp2	call    LINE1		;  1  1- 
	movlw	3ch		; "<"
	call	SENDD
	movlw	58h		; "X"
	call	SENDD
	movlw	3eh		; ">"
	call	SENDD
	movlw	20h		; "_"
	call	SENDD	
	movlw	3ch		; "<"
	call	SENDD
	movlw	59h		; "Y"
	call	SENDD
	movlw	3eh		; ">"
	call	SENDD
	movlw	20h		; "_"
	call	SENDD
	movlw	3ch		; "<"
	call	SENDD
	movlw	5ah		; "Z"
	call	SENDD
	movlw	3eh		; ">"
	call	SENDD
	
	movlw	20h		; "_"
	call	SENDD		
	movf	znakt,w		;    z
	call	SENDD
	movf	egt,w		;    Z
	addlw	30
	call	SENDD
	movf	ddgt,w		;     Z
	addlw	30
	call	SENDD
	movlw	43h		; "C"
	call	SENDD
	RETURN

;******************************************************
;	 "XX,X YY,Y ZZ,Z TT,T"
;******************************************************

DISPLAY2
	call    LINE2		;  1  2- 
	movf	znakx,w		;    X
	call	SENDD
	movf	egx,w		;    X
	addlw	30
	call	SENDD
	movf	ddgx,w		;     X
	addlw	30
	call	SENDD
	movlw	20h		; ""
	call	SENDD

	movf	znaky,w		;    y
	call	SENDD
	movf	egy,w		;    Y
	addlw	30
	call	SENDD
	movf	ddgy,w		;     Y
	addlw	30
	call	SENDD
	movlw	20h		; ""
	call	SENDD

	movf	znakz,w		;    z
	call	SENDD
	movf	egz,w		;    Z
	addlw	30
	call	SENDD
	movf	ddgz,w		;     Z
	addlw	30
	call	SENDD
	movlw	20h		; "_"
	call	SENDD
	movlw	20h		; "_"
	call	SENDD
	movlw	3ch		; "<"
	call	SENDD
	movf	z_zero,w	;    y
	call	SENDD
	movlw	3eh		; ">"
	call	SENDD
	return

;*********************************************
;     .. SPI  (\)
;     spiTempOut -   
;     spiTempIn  -  	
;*********************************************
SPI:	bcf	mmcSCK		;
	btfss	spiTempOut,7
	bcf	mmcSDO
	btfsc	spiTempOut,7
	bsf	mmcSDO

	bsf	mmcSCK		;
	btfss	mmcSDI		;  spiTempIn	
	bcf	spiTempIn,7
	btfsc	mmcSDI
	bsf	spiTempIn,7

	bcf	mmcSCK		;
	btfss	spiTempOut,6
	bcf	mmcSDO
	btfsc	spiTempOut,6
	bsf	mmcSDO

	bsf	mmcSCK		;
	btfss	mmcSDI		;  spiTempIn	
	bcf	spiTempIn,6
	btfsc	mmcSDI
	bsf	spiTempIn,6

	bcf	mmcSCK		;
	btfss	spiTempOut,5
	bcf	mmcSDO
	btfsc	spiTempOut,5
	bsf	mmcSDO
	
	bsf	mmcSCK		;_|
	btfss	mmcSDI		;  spiTempIn	
	bcf	spiTempIn,5
	btfsc	mmcSDI
	bsf	spiTempIn,5

	bcf	mmcSCK		;
	btfss	spiTempOut,4
	bcf	mmcSDO
	btfsc	spiTempOut,4
	bsf	mmcSDO

	bsf	mmcSCK		;_|
	btfss	mmcSDI		;  spiTempIn	
	bcf	spiTempIn,4
	btfsc	mmcSDI
	bsf	spiTempIn,4

	bcf	mmcSCK		;
	btfss	spiTempOut,3
	bcf	mmcSDO
	btfsc	spiTempOut,3
	bsf	mmcSDO

	bsf	mmcSCK		;_|
	btfss	mmcSDI		;  spiTempIn	
	bcf	spiTempIn,3
	btfsc	mmcSDI
	bsf	spiTempIn,3

	bcf	mmcSCK		;
	btfss	spiTempOut,2
	bcf	mmcSDO
	btfsc	spiTempOut,2
	bsf	mmcSDO

	bsf	mmcSCK		;_|
	btfss	mmcSDI		;  spiTempIn	
	bcf	spiTempIn,2
	btfsc	mmcSDI
	bsf	spiTempIn,2

	bcf	mmcSCK		;
	btfss	spiTempOut,1
	bcf	mmcSDO
	btfsc	spiTempOut,1
	bsf	mmcSDO

	bsf	mmcSCK		;_|
	btfss	mmcSDI		;  spiTempIn	
	bcf	spiTempIn,1
	btfsc	mmcSDI
	bsf	spiTempIn,1

	bcf	mmcSCK		;
	btfss	spiTempOut,0
	bcf	mmcSDO
	btfsc	spiTempOut,0
	bsf	mmcSDO

	bsf	mmcSCK		;_|
	btfss	mmcSDI		;  spiTempIn	
	bcf	spiTempIn,0
	btfsc	mmcSDI
	bsf	spiTempIn,0

	movf	spiTempIn,W
	return

;*************************************************
;     
;*************************************************.
int  		  retfie

;****************************************************

	org	0x600	
g_table:
	bcf	PCLATH,0
	bsf	PCLATH,1
	bsf	PCLATH,2

	addwf	PCL,F
  dt	.0, .0, .1, .1, .2, .2, .3, .3, .4, .4, .5, .5, .6, .6, .7 
  dt	.7, .8, .8, .9, .9, .10, .10, .11, .11, .12, .12, .13, .13
  dt    .14, .14, .15, .15, .16, .16, .17, .17, .18, .18, .19, .19
  dt	.20, .20, .21, .21, .22, .22, .23, .23, .24, .24, .25, .25
  dt	.26, .26, .27, .27, .28, .28, .29, .29, .30, .30, .31, .31
  dt	.32, .32, .33, .33, .34, .34, .35, .35, .36, .36, .37, .37
  dt    .38, .38, .39, .39, .40, .40, .41, .41, .42, .42, .43, .43
  dt    .44, .44, .45, .45, .46, .46, .47, .47, .48, .48, .49, .49
  dt	.50, .50, .51, .52, .53, .54, .55, .56, .57, .58, .59, .60
  dt	.61, .62, .63, .64, .65, .66, .67, .68, .69, .70, .70, .70
  dt	.75, .75, .75, .80, .80, .85, .85, .90, .90, .90, .90, .90
  dt	.90, .90, .90, .90, .90, .90, .90, .90, .90, .90, .90, .90
  dt	.90, .90, .90, .90, .90, .90, .90, .90, .90, .90, .90, .90
 

;*************************************************
	ORG	0x00002007	; 
	DW	0x3F18
	
	 END












